<?php
/**
 * Helper functions related to customizer and options.
 *
 * @package bookstore_exhibition
 */

if ( ! function_exists( 'bookstore_exhibition_get_global_layout_options' ) ) :

	/**
	 * Returns global layout options.
	 *
	 * @since 1.0.0 
	 *
	 * @return array Options array.
	 */
	function bookstore_exhibition_get_global_layout_options() {

		$choices = array(
			'left-sidebar'  => esc_html__( 'Primary Sidebar - Content', 'bookstore-exhibition' ),
			'right-sidebar' => esc_html__( 'Content - Primary Sidebar', 'bookstore-exhibition' ),
			'three-columns' => esc_html__( 'Three Columns', 'bookstore-exhibition' ),
			'four-columns' => esc_html__( 'Four Columns', 'bookstore-exhibition' ),
			'no-sidebar'    => esc_html__( 'No Sidebar', 'bookstore-exhibition' ),
		);
		$output = apply_filters( 'bookstore_exhibition_filter_layout_options', $choices );
		return $output;

	}

endif;

if ( ! function_exists( 'bookstore_exhibition_get_archive_layout_options' ) ) :

	/**
	 * Returns archive layout options.
	 *
	 * @since 1.0.0
	 *
	 * @return array Options array.
	 */
	function bookstore_exhibition_get_archive_layout_options() {

		$choices = array(
			'full'    => esc_html__( 'Full Post', 'bookstore-exhibition' ),
			'excerpt' => esc_html__( 'Post Excerpt', 'bookstore-exhibition' ),
		);
		$output = apply_filters( 'bookstore_exhibition_filter_archive_layout_options', $choices );
		if ( ! empty( $output ) ) {
			ksort( $output );
		}
		return $output;

	}

endif;

if ( ! function_exists( 'bookstore_exhibition_get_image_sizes_options' ) ) :

	/**
	 * Returns image sizes options.
	 *
	 * @since 1.0.0
	 *
	 * @param bool  $add_disable True for adding No Image option.
	 * @param array $allowed Allowed image size options.
	 * @return array Image size options.
	 */
	function bookstore_exhibition_get_image_sizes_options( $add_disable = true, $allowed = array(), $show_dimension = true ) {

		global $_wp_additional_image_sizes;
		$get_intermediate_image_sizes = get_intermediate_image_sizes();
		$choices = array();
		if ( true === $add_disable ) {
			$choices['disable'] = esc_html__( 'No Image', 'bookstore-exhibition' );
		}
		$choices['thumbnail'] = esc_html__( 'Thumbnail', 'bookstore-exhibition' );
		$choices['medium']    = esc_html__( 'Medium', 'bookstore-exhibition' );
		$choices['large']     = esc_html__( 'Large', 'bookstore-exhibition' );
		$choices['full']      = esc_html__( 'Full (original)', 'bookstore-exhibition' );

		if ( true === $show_dimension ) {
			foreach ( array( 'thumbnail', 'medium', 'large' ) as $key => $_size ) {
				$choices[ $_size ] = $choices[ $_size ] . ' (' . get_option( $_size . '_size_w' ) . 'x' . get_option( $_size . '_size_h' ) . ')';
			}
		}

		if ( ! empty( $_wp_additional_image_sizes ) && is_array( $_wp_additional_image_sizes ) ) {
			foreach ( $_wp_additional_image_sizes as $key => $size ) {
				$choices[ $key ] = $key;
				if ( true === $show_dimension ){
					$choices[ $key ] .= ' ('. $size['width'] . 'x' . $size['height'] . ')';
				}
			}
		}

		if ( ! empty( $allowed ) ) {
			foreach ( $choices as $key => $value ) {
				if ( ! in_array( $key, $allowed ) ) {
					unset( $choices[ $key ] );
				}
			}
		}

		return $choices;

	}

endif;


if ( ! function_exists( 'bookstore_exhibition_get_image_alignment_options' ) ) :

	/**
	 * Returns image options.
	 *
	 * @since 1.0.0
	 *
	 * @return array Options array.
	 */
	function bookstore_exhibition_get_image_alignment_options() {

		$choices = array(
			'none'   => _x( 'None', 'alignment', 'bookstore-exhibition' ),
			'left'   => _x( 'Left', 'alignment', 'bookstore-exhibition' ),
			'center' => _x( 'Center', 'alignment', 'bookstore-exhibition' ),
			'right'  => _x( 'Right', 'alignment', 'bookstore-exhibition' ),
		);
		return $choices;

	}

endif;

if ( ! function_exists( 'bookstore_exhibition_get_featured_slider_transition_effects' ) ) :

	/**
	 * Returns the featured slider transition effects.
	 *
	 * @since 1.0.0
	 *
	 * @return array Options array.
	 */
	function bookstore_exhibition_get_featured_slider_transition_effects() {

		$choices = array(
			'fade'       => _x( 'fade', 'transition effect', 'bookstore-exhibition' ),
			'fadeout'    => _x( 'fadeout', 'transition effect', 'bookstore-exhibition' ),
			'none'       => _x( 'none', 'transition effect', 'bookstore-exhibition' ),
			'scrollHorz' => _x( 'scrollHorz', 'transition effect', 'bookstore-exhibition' ),
		);
		$output = apply_filters( 'bookstore_exhibition_filter_featured_slider_transition_effects', $choices );

		if ( ! empty( $output ) ) {
			ksort( $output );
		}

		return $output;

	}

endif;

if ( ! function_exists( 'bookstore_exhibition_get_featured_slider_content_options' ) ) :

	/**
	 * Returns the featured slider content options.
	 *
	 * @since 1.0.0
	 *
	 * @return array Options array.
	 */
	function bookstore_exhibition_get_featured_slider_content_options() {

		$choices = array(
			'home-page' => esc_html__( 'Static Front Page Only', 'bookstore-exhibition' ),
			'disabled'  => esc_html__( 'Disabled', 'bookstore-exhibition' ),
		);
		$output = apply_filters( 'bookstore_exhibition_filter_featured_slider_content_options', $choices );
		if ( ! empty( $output ) ) {
			ksort( $output );
		}
		return $output;

	}

endif;

if ( ! function_exists( 'bookstore_exhibition_get_featured_slider_type' ) ) :

	/**
	 * Returns the featured slider type.
	 *
	 * @since 1.0.0
	 *
	 * @return array Options array.
	 */
	function bookstore_exhibition_get_featured_slider_type() {

		$choices = array(
			'featured-page' => __( 'Featured Pages', 'bookstore-exhibition' ),
		);

		$output = apply_filters( 'bookstore_exhibition_filter_featured_slider_type', $choices );

		if ( ! empty( $output ) ) {
			ksort( $output );
		}

		return $output;

	}

endif;

if ( ! function_exists( 'bookstore_exhibition_get_numbers_dropdown_options' ) ) :

	/**
	 * Returns numbers dropdown options.
	 *
	 * @since 1.0.0
	 *
	 * @param int $min Min.
	 * @param int $max Max.
	 * @param string $prefix Prefix.
	 * @param string $suffix Suffix.
	 *
	 * @return array Options array.
	 */
	function bookstore_exhibition_get_numbers_dropdown_options( $min = 1, $max = 4, $prefix = '', $suffix = '' ) {

		$output = array();

		if ( $min <= $max ) {
			for ( $i = $min; $i <= $max; $i++ ) {
				$string = $prefix . $i . $suffix;
				$output[ $i ] = $string;
			}
		}

		return $output;

	}

endif;